/**********************************************************************************************
 * This example code is provided for illustrative purposes only and provided 'AS IS' without 
 * warranty of any kind.
 * 
 * Copyright ©2014 Chrysler Group LLC.  All Rights Reserved.  All information contained herein is,
 * and remains the property of Chrysler Group LLC and its suppliers, if any.  The intellectual and
 * technical concepts contained herein are proprietary to Chrysler Group LLC and its suppliers
 * and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secret or copyright law. Dissemination of this information or reproduction of this material is
 * strictly forbidden unless prior written permission is obtained from Chrysler Group LLC.
 *
 * Chrysler, Jeep, Dodge, Ram, SRT, Mopar and the Pentastar logo are registered trademarks of
 * Chrysler Group LLC. FIAT is a registered trademark of Fiat group Marketing & Corporate
 * Communication S.p.A. used under license by Chrysler Group LLC.
 *********************************************************************************************/
package com.fca.uconnect.global;

import java.util.ArrayList;
import java.util.List;

import com.amazonaws.services.iot.client.AWSIotException;
import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotMqttClient;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;
import com.fca.uconnect.global.GlobalUconnectControl.Device;
import com.fca.uconnect.global.GlobalUconnectControl.Device.DeviceType;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectAny;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectMessage;
import com.fca.uconnect.global.GlobalUconnectExtProvision.ProvisioningRequest;
import com.fca.uconnect.global.GlobalUconnectExtProvision.ProvisioningResponse;
import com.google.protobuf.ByteString;
import com.google.protobuf.ExtensionRegistry;
import com.google.protobuf.InvalidProtocolBufferException;

/**
 * This example class demonstrates how to use the AWS IoT mqtt client to send a Uconnect Provisioning message to the SDP and wait for a response message.   
 * This code is only for reference and is furnished without warranty.....
 * 
 * @author FCA Global V2C API Team
 *
 */
public class TBMExampleForProvisioning {

	private String clientId; // The clientId is unique to the device and obtained from the client X.509 certificate CN.
	private ByteString sessionId; // The sessionId is assigned by the SDP to maintain a session independent of connection protocols.
	private int messageId; // The messageId is a sequential number incremented and assigned to each message sent from the client.
	private AWSIotMqttClient mqttClient; // The mqtt client object from the AWS IoT client library. 
	private AWSIotTopic iotTopic; // The Topic object to subscribe for inbound messages.
	private ExtensionRegistry extRegistry; // Google protocol buffers extension registry instance.
	private Semaphore semaphore;//The semaphore object is used to wait for a response.
	private List<UconnectAny> messages;
	/**
	 * Constructor - initialize protocol buffer extension registry for parsing incoming Uconnect Messages.
	 */
	public TBMExampleForProvisioning() {
		extRegistry = ExtensionRegistry.newInstance();
		extRegistry.add(GlobalUconnectExtProvision.provisioningResponse);
		this.semaphore = new Semaphore();
	}
	
	/**
	 * This method generates a Protocol Buffer Uconnect Message given the required inputs for Provisioning.
	 * 
	 * @param vehicleId
	 * @return UconnectMessage Protocol Buffer
	 */
	public UconnectMessage getProvisioningReqMsg(String vehicleId) {
		this.messageId++;
		Device device = Device.newBuilder()
				.setDeviceType(DeviceType.VP4)
				.setHuSerialNum("HUSerialNbr")
				.setHuFirmwareVersion("HUVersion")
				.setTbmFirmwareVersion("TBM Version")
				.setTbmSerialNum("TBMSerial Nbr")
				.setIccid("ICCID")
				.setImei("IMEI")
				.setMsisdn("MSDISDN")
				.build();
		ProvisioningRequest pr = ProvisioningRequest.newBuilder()
				.setVehicleId(vehicleId)
				.setDevice(device)
				.build();
		UconnectMessage msg = UconnectMessage.newBuilder()
			.setTimestamp(System.currentTimeMillis())
			.setMessageId(messageId)
			.addMessages(UconnectAny.newBuilder().
			 setExtension(GlobalUconnectExtProvision.provisioningRequest, pr))
			.build();

		return msg;		
	}
	
	/**
	 * This method demonstrates connecting to the AWS IoT mqtt broker and publishing an Provisioning message to the PRVI topic.
	 */
	public List<UconnectAny> process() {
		
		mqttClient = new AWSIotMqttClient("endpoint", clientId, "awsAccessKeyId", "awsSecretAccessKey");
		
		try {			
			mqttClient.connect();						
						
			iotTopic = new AWSIotTopic(clientId+"/PRVI/", AWSIotQos.QOS1) {
				public void onMessage(AWSIotMessage msg) {

					UconnectMessage msgIn = null;
					try {
						msgIn = UconnectMessage.parseFrom(msg.getPayload(),extRegistry);
					} catch (InvalidProtocolBufferException e) {					
					}
					if (msgIn.getMessages(0).hasExtension(GlobalUconnectExtProvision.provisioningResponse)) {
						ProvisioningResponse provisioningMsg = msgIn.getMessages(0).getExtension(GlobalUconnectExtProvision.provisioningResponse);
						semaphore.unlock();// Releasing the lock as it received response
						if(messages==null)
							messages = new ArrayList<UconnectAny>();
						messages.add(msgIn.getMessages(0));
					}
					
				}	
			};
			mqttClient.subscribe(iotTopic);
			UconnectMessage msg = getProvisioningReqMsg("562X4423AE122");

			AWSIotMessage message = new 
					MessagePublisherListener("/PRVI/"+clientId,AWSIotQos.QOS1,msg.toByteArray());
			mqttClient.publish(message);
			this.semaphore.lock();	//Wait for response, lock thread
			
		} catch (AWSIotException ex) {
			System.out.println("Caught AWS Exception "+ex);
			ex.printStackTrace();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		return messages;
	}
	public void disconnect(){
		try {
			mqttClient.disconnect();
		} catch (AWSIotException e) {
			e.printStackTrace();
		}
	}
	/**
	 * Example main to launch example.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		TBMExampleForProvisioning example = new TBMExampleForProvisioning();
		example.process();
	}

}
